#!/usr/bin/env python
# encoding=utf-8 (pep 0263)

from linked_lists import Cons, Nil

def solution(node):
    for path in depth_first_search(Nil, node):
        yield path

def depth_first_search(akumulator_path, node):
    akumulator_path1 = Cons(node, akumulator_path)
    if is_goal(node):
        yield akumulator_path1
    for node1 in move_anyY(node):
        for path in depth_first_search(akumulator_path1, node1):
            yield path

def is_goal(_):
    # zavisi na resenem problemu
    return False

def move_anyY(x):
    # zavisi na resenem problemu
    yield x
