#!/usr/bin/env python
# encoding=utf-8 (pep 0263)

from linked_lists import Cons, Nil

def solution(node):
    for path in depth_first_search(node, 999):
        yield path

def depth_first_search(start_node, max_depth):
    paths = [(Cons(start_node, Nil), max_depth)] # pouzijeme pythonovsky seznam jako LIFO
    while len(paths) > 0:
        path, remaining_depth = paths.pop()
        node = path.head
        if is_goal(node):
            yield path
        if remaining_depth > 0:
            for node1 in move_anyY(node):
                paths.append((Cons(node1, path), remaining_depth-1))

def is_goal(_):
    # zavisi na resenem problemu
    return False

def move_anyY(x):
    # zavisi na resenem problemu
    yield x
